<?php
require_once "FszNotenVerwaltungConfig.class.php";
require_once "FszNotenVerwaltung.class.php";
require_once "lib/datei.inc.php";
require_once "vendor/flexi/flexi.php";

class FszNotenVerwaltungPlugin extends AbstractStudIPStandardPlugin {
	
	var $template_factory;

	/**
	 * 
	 */
	function FszNotenVerwaltungPlugin(){
		AbstractStudIPStandardPlugin::AbstractStudIPStandardPlugin();
		$this->setPluginiconname('images/icon_zensus_neu.gif');
		$this->setChangeindicatoriconname('images/icon_zensus_neu_changed.gif');
		$this->seminar_id =& $GLOBALS['SessSemName'][1];
		$this->template_factory = new Flexi_TemplateFactory(dirname(__FILE__).'/templates/');
		if ($this->isVisible()){
			$navigation = new PluginNavigation();
			$navigation->setDisplayname(_("Notenverwaltung"));
			$navigation->addLinkParam('action', 'main');
			if ($GLOBALS['perm']->have_studip_perm('dozent', $this->seminar_id)){
				$config_nav =& new PluginNavigation();
				$config_nav->setDisplayname(_("Einstellungen"));
				$config_nav->addLinkParam('action', 'config');
				$navigation->addSubmenu($config_nav);
			}
			$this->setNavigation($navigation);
		}
	}
	
	function initialize(){
		$this->config =& new FszNotenVerwaltungConfig($this->seminar_id);
	}
	
	function isShownInOverview(){
		return false;
	}
	
	function getOverviewMessage($has_changed = false){
	}
	
	function isVisible(){
		return $GLOBALS['perm']->have_studip_perm('dozent', $this->seminar_id) || $this->config->conf['VISIBLE'];
	}
	
	function actionShow(){
		if(!is_object($this->config)) $this->initialize();
		if (!$this->isVisible()) return;
		if($GLOBALS['perm']->have_studip_perm('dozent', $this->seminar_id)){
			if($_REQUEST['action'] == 'send_excel_sheet'){
				$tmpfile = basename($this->createExcelSheet());
				if($tmpfile){
					header('Location: ' . getDownloadLink($tmpfile, _("Notenvergabe.xls"), 4));
					page_close();
					die;
				}
			} else if($_REQUEST['action'] == 'config'){
				return $this->displayConfigPage();
			} else {
				return $this->displayMainPage();
			}
		} else {
			return $this->displayStudentInfoPage();
		}
	}
	
	function displayConfigPage(){
		$msg = array();
		if(isset($_REQUEST['save_x']) || isset($_REQUEST['add_mark_x'])){
			$this->config->conf['VISIBLE'] = isset($_REQUEST['visible']);
			foreach($_REQUEST['marks'] as $id => $data){
				$this->config->marks[$id]['desc'] = trim(stripslashes($data['desc']));
				$this->config->marks[$id]['weight'] = abs((int)$data['weight']);
				$weight += (int)$data['weight'];
			}
			if(isset($_REQUEST['add_mark_x'])){
				$this->config->marks[$this->config->getNewId()] = array('desc' => '', 'weight' => ($weight < 100 ? 100 - $weight : 0));
				if($weight > 100) $msg[] = array('info', _("Die Summe der Gewichtung berschreitet 100%!"));
			}
			if(isset($_REQUEST['save_x'])) {
				if($weight == 0){
					$msg[] = array('error', _("Die Summe der Gewichtung darf nicht Null sein! Bitte korrigieren Sie die Werte."));
				} else {
					if($this->config->store()){
						$msg[] = array('msg', _("Die Daten wurden gespeichert."));
					} else {
						$msg[] = array('error', _("Ein Fehler ist aufgetreten. Die Werte konnten nicht gespeichert werden."));
					}
				}
			}
		}
		if(strlen($_REQUEST['delete_mark'])){
			if($this->config->deleteMark($_REQUEST['delete_mark'])){
				$msg[] = array('msg', _("Die Einzelnote wurde gelscht."));
			}
		}
		if(!count($this->config->marks)) $this->config->marks[$this->config->getNewId()] = array('desc' => '', 'weight' => 100);
		$template = $this->template_factory->open('config');
		$template->set_attribute('msg', $msg);
        $template->set_attribute('plugin', $this);
		$template->set_attribute('config', $this->config);
        echo $template->render();
	}
	
	function displayMainPage(){
		$msg = array();
		$fsz =& new FszNotenVerwaltung($this->seminar_id);
		if(isset($_REQUEST['save_x'])){
			foreach($_REQUEST['usermark'] as $key => $value){
				list($user_id,$config_id) = explode('-',$key);
				$value = (float)abs(str_replace(',','.',$value));
				if($value || (!$value && $fsz->getValue($user_id,$config_id,'chdate'))){
					$fsz->setValue($user_id,$config_id,'value',$value);
				}
			}
			if($fsz->store()){
				$msg[] = array('msg', _("Die Daten wurden gespeichert."));
			}
		}
		if(!count($fsz->members)){
			$msg[] = array('info', _("In dieser Veranstaltung sind noch keine Teilnehmer eingetragen!."));
		}
		if(!count($fsz->config->marks)){
			$msg[] = array('info', _("Sie haben noch keine Einzelnoten festgelegt. Das knnen sie unter \"Einstellungen\" tun."));
		}
		
		$template = $this->template_factory->open('main');
		$template->set_attribute('msg', $msg);
        $template->set_attribute('plugin', $this);
		$template->set_attribute('fsz', $fsz);
        echo $template->render();
	}
	
	function displayStudentInfoPage(){
		$msg = array();
		$fsz =& new FszNotenVerwaltung($this->seminar_id);
		if(is_null($fsz->getFinalGrade($GLOBALS['user']->id))){
			$msg[] = array('info', _("Ihre Gesamtnote steht noch nicht fest."));
		}
		$template = $this->template_factory->open('main_student');
		$template->set_attribute('user_id', $GLOBALS['user']->id);
		$template->set_attribute('msg', $msg);
		$template->set_attribute('fsz', $fsz);
        echo $template->render();
	}
	
	function createExcelSheet(){
		require_once "vendor/write_excel/OLEwriter.php";
		require_once "vendor/write_excel/BIFFwriter.php";
		require_once "vendor/write_excel/Worksheet.php";
		require_once "vendor/write_excel/Workbook.php";

		$tempfile = null;
		$fsz =& new FszNotenVerwaltung($this->seminar_id);
		$seminar =& Seminar::GetInstance($this->seminar_id);
		$semester =& SemesterData::GetInstance();
		$one_semester = $semester->getSemesterDataByDate($seminar->getSemesterStartTime());
		
		$tmpfile = $GLOBALS['TMP_PATH'] . '/' . md5(uniqid('write_excel',1));
		// Creating a workbook
		$workbook = new Workbook($tmpfile);
		$head_format =& $workbook->addformat();
		$head_format->set_size(12);
		$head_format->set_bold();
		$head_format->set_align("left");
		$head_format->set_align("vcenter");
		
		$head_format_merged =& $workbook->addformat();
		$head_format_merged->set_size(12);
		$head_format_merged->set_bold();
		$head_format_merged->set_align("left");
		$head_format_merged->set_align("vcenter");
		$head_format_merged->set_merge();
		$head_format_merged->set_text_wrap();
		
		$caption_format =& $workbook->addformat();
		$caption_format->set_size(10);
		$caption_format->set_align("left");
		$caption_format->set_align("vcenter");
		$caption_format->set_bold();
		//$caption_format->set_text_wrap();
		
		$data_format =& $workbook->addformat();
		$data_format->set_size(10);
		$data_format->set_align("left");
		$data_format->set_align("vcenter");
		
		$caption_format_merged =& $workbook->addformat();
		$caption_format_merged->set_size(10);
		$caption_format_merged->set_merge();
		$caption_format_merged->set_align("left");
		$caption_format_merged->set_align("vcenter");
		$caption_format_merged->set_bold();
		
		// Creating the first worksheet
		$worksheet1 =& $workbook->addworksheet(_("Notenverwaltung"));
		
		$max_col = 5 + count($fsz->config->marks);
		
		foreach(range(1,$max_col) as $c) $worksheet1->write_blank(0,$c,$head_format);
		foreach(range(1,$max_col) as $c) $worksheet1->write_blank(1,$c,$head_format);
		foreach(range(0,$max_col) as $c) $worksheet1->set_column(1, $c, 15);
		
		$worksheet1->set_row(0, 20);
		$worksheet1->write_string(0, 0, _("Notenvergabe") . ' - ' . $seminar->getName() . ' ('.$one_semester['name'].')',$head_format);
		$worksheet1->set_row(1, 20);
		
		$row = 2;
		$c = 0;
		
		$worksheet1->write_string($row,$c++, _("Nachname"), $caption_format);
		$worksheet1->write_string($row,$c++, _("Vorname"), $caption_format);
		$worksheet1->write_string($row,$c++, _("Matrikelnummer"), $caption_format);
		foreach($fsz->config->marks as $mark) {
			$worksheet1->write_string($row, $c++, $mark['desc'] ? $mark['desc'] : (($c-3) . '. Einzelnote') . ' ('.$mark['weight'].'%)', $caption_format);
		}
		$worksheet1->write_string($row,$c++, _("Gesamtnote"), $caption_format);
		$worksheet1->write_string($row,$c++, _("Gendert am"), $caption_format);
		$worksheet1->write_string($row,$c++, _("Gendert von"), $caption_format);
		
		++$row;
		foreach($fsz->members as $user_id => $user_data){
			$c = 0;
			$worksheet1->write_string($row, $c++, $user_data['Nachname'], $data_format);
			$worksheet1->write_string($row, $c++, $user_data['Vorname'], $data_format);
			$worksheet1->write_string($row, $c++, $user_data['Matrikelnummer'], $data_format);
			$changed = array();
			foreach(array_keys($fsz->config->marks) as $mid) {
				$worksheet1->write_string($row, $c++, $fsz->getValue($user_id, $mid, 'value'), $data_format);
				$changed[$fsz->getValue($user_id, $mid, 'chdate')] = $fsz->getValue($user_id, $mid, 'changed_by_user_id');
			}
			$final = $fsz->getFinalGrade($user_id);
			if($final) echo $final = round($final,1);
			else $final = '';
			ksort($changed, SORT_NUMERIC);
			list($last_changed, $last_changed_user_id) = each($changed);
			$worksheet1->write_string($row, $c++, $final , $data_format);
			$worksheet1->write_string($row, $c++, ($last_changed > 0 ? date("d.m.Y G:i", $last_changed) : '') , $data_format);
			$worksheet1->write_string($row, $c++, ($last_changed_user_id ? get_fullname($last_changed_user_id) : '') , $data_format);
			++$row;
		}
		$workbook->close();
	return $tmpfile;
	}
}
?>